#include<stdio.h>
#include<math.h>
#include"SimpleImage.h"
#include"pgmio.h"

/* ヒストグラム(頻度表)作成用関数:
　　Lec04.pdfの演習4-5ヒント参照 */
void makeHistogram(long long *hist,int N,Image *in){
  int i,j;
  /* ヒストグラムの初期化 */
  for(i=0;i<N;i++)hist[i]=((long long)(0));
  /* 画素を辿る2重ループ */
  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      /* 輝度値をグレーレベルで割ってビンの数-1をかける事で、0～Nの範囲へ変換 */
      double val = ((double)(N-1))*(in->img[i][j]/((double)(in->gray)));
      /* 整数へ変換 */
      int vali = ((int)(val));
      /* 四捨五入 */
      if(val-((double)(vali))>=0.5)vali++;
      /* Nより大きかったらN-1へ */
      if(vali>=N)vali=N-1;
      /* ヒストグラムのvali番目のビンに1をたす */
      hist[vali]++;
    }
}

 
 
   
/*
ヒストグラム(頻度表)hist[]を閾値thrで分けた場合のクラス間分散を計算する関数 

 */
  double getSmax(int thr,int N,long long *hist){
    long long mn1;/* hist[0]～hist[thr-1]までの頻度の合計 */
    long long mn2;/* hist[thr]～hist[N-1]までの頻度の合計 */
    double m1; /* hist[0]～hist[thr-1]までの輝度値の平均(頻度×ビンのID/頻度の合計) */
    /* 平均を求めるときに、mn1とmn2がゼロでない場合に割る事に注意 */
    double m2; /* hist[thr]～hist[N-1]までの輝度値の平均(頻度×ビンのID/頻度の合計) */
    double Smax;/* クラス間分散 
		   (mn1*mn2*(m1-m2)^2)/(mn1+mn2)^2
		  Lec07.pdfを参照 */

    /* 
       注意: 大きさ(mn1+mn2)^2はどの閾値thrでも同じなので、Smaxの計算に含めなくてよい
    */
    /* ここを編集し、m1,m2,mn1,mn2,Smaxを計算する */

    
    return Smax;
  }

/* 大津法で閾値を計算する関数 */
int find_hist_threshold(Image *in,int N){
  /* ヒストグラム:ビンの数N */
  long long *hist = new long long[N];
  /* ヒストグラムの作成 */
  makeHistogram(hist,N,in);

  
  /* 初期化：閾値が0の場合のクラス間分散を計算 */
  int Tmax=0;
  double Smax = getSmax(0,N,hist);
  int i;
  
  /*以下を編集しクラス間分散を最大化する閾値Tmaxを計算する */
  /* 閾値が1～N-1までのクラス間分散を計算し最大となる閾値をTmaxとする */
  /* 閾値のループここから */
  
  /* 閾値がiのときのクラス間分散を計算 */
  
  /* もしもSがSmaxより大きい場合はTmaxとSmaxを更新 */
  
  
  /* 閾値のループここまで　*/

  /* メモリの開放 */
  delete [] hist;
  /* クラス間分散を最大化する閾値Tmaxを返す */
  return Tmax;
}


int main(int argc,char *argv[]){
  /* 入力用の画像クラス */
  Image *in = new Image();
  
  /* pgm画像の読み込み 第一引数 argv[1]に入力pgmファイル名 */
  getPGM(in,argv[1]);
  
  /* 入力画像と同じサイズで出力用の画像クラス(オブジェクト)を作成 */
  Image *out = new Image(in->sx,in->sy);
  
  /* 大津法で閾値を計算 */
  int otsu_threshold = find_hist_threshold(in,256);
  printf("Otsu's Threshold = %d\n",otsu_threshold);
  int i,j;
  /* 計算した閾値で二値化 */
  /* 画素を辿る2重ループ */
  for(i=0;i<in->sy;i++)
    for(j=0;j<in->sx;j++){
      /*座標(i,j)での輝度値in->img[i][j]が閾値以上、未満で二値化 */
      if(in->img[i][j]>=otsu_threshold){
	out->img[i][j] = 255.0;
      }else{
	out->img[i][j] = 0.0;
      }
    }
  /* 出力用画像を第二引数argv[2]の名前でpgm画像として保存 */
  savePGM(out,argv[2]);

  /* メモリの開放 */
  delete in;
  delete out;

  return 0;
}

